/*
 
Copyright (C) 2004-2005  Stichting Mathematisch Centrum,
                         Amsterdam, The Netherlands
 
*/


import de.tu_berlin.cs.uebb.muttcn.runtime.*;
import org.etsi.ttcn.tci.*;
import org.etsi.ttcn.tri.*;
import com.testingtech.ttcn.tci.codec.base.AbstractBaseCodec;
import org.etsi.ttcn.tci.TciTypeClass;
import com.testingtech.ttcn.tri.TriMessageImpl;
import java.io.*;

/**
 * Termination detection message implementation.
 * This class provide the data structure for terminaiton detection messages
 * and the methods for conversion to and from TTCN-3 formats.
 *
 * @author Stefan Blom
 * @version 1.0
 */
public class TermMsg {

public static int IDLE = 1;
public static int RUNNING = 2;
public static int TERM = 3;

public int tag=0;
public int count=0;

/// Create a new message.
  public TermMsg(){
  }

/// Convert a TriMessage to a Java class.
  public TermMsg(TriMessage message){
	try {
		DataInputStream src=new DataInputStream(new ByteArrayInputStream(message.getEncodedMessage()));
		tag=src.readByte();
		if (tag==IDLE) count=src.readInt();
	} catch (IOException e) {
		throw new Error("IOException: "+e);
	}
  }

/// Convert a Value to a Java class.
  public TermMsg(Value value){
	tag=((IntegerValue)((RecordValue)value).getField("tag")).getInt();
	if (tag==IDLE) count=((IntegerValue)((RecordValue)value).getField("count")).getInt();
  }

/// Convert an object to a TriMessage.
  public TriMessage toTriMessage(){
	try {
		ByteArrayOutputStream data=new ByteArrayOutputStream();
		DataOutputStream dst=new DataOutputStream(data);
		dst.writeByte((byte)tag);
		if (tag==1) dst.writeInt(count);
		dst.flush();
		return new TriMessageImpl(data.toByteArray());
	} catch (IOException e) {
		throw new Error("IOException: "+e);
	}	
  }

/// Convert an object to a Value.
  public void writeValue(Value value){
	IntegerValue tmp;
	tmp=(IntegerValue)((RecordValue)value).getField("tag");
	tmp.setInt(tag);
	((RecordValue)value).setField("tag",tmp);
	((IntegerValue)((RecordValue)value).getField("count")).setInt(count);
  }

}

